# How to Contribute

- Questions/ideas about the module &#x21D2; [Create a Discussion]

- Report bug or suggest specific improvement/feature &#x21D2; [Create an Issue]

- Submit changes &#x21D2; Create a pull request

## Rules for Contributions

- Contributors agrees that their contribution will be made available under the project license if no other license is specified.

- Before developing big improvements/features, it's advisable to discuss the proposed changes in an Issue beforehand. This way, you won't risk wasting a lot of your precious time if the pull request ends up being rejected and not integrated into the repository. Furthermore, announcing via Issues who's working on which feature (or planning to do so) prevents duplication of efforts.

- For a pull request, a feature branch should be created from the `dev` branch, and the pull request should target the `dev` branch.

## Commits Guidelines

- Subject line and text should be separated by a blank line.

- Subject line should not end with a period.

- Subject line should be written in imperative.

- Lines length should not exceed 72 characters.

- Text should explain _what_ and _why_, not _how_.

## Code Conventions

- Each file should end with a blank line, if possible.

- Line length of code comments should preferably not exceed 80 characters.

- PureBasic code files should not contain PureBasic IDE settings at the end.

<!--------------------------------------------------------------------------->

[Create a Discussion]: https://github.com/SicroAtGit/RegEx-Engine/discussions/new/choose "Create a new Discussion at SicroAtGit/RegEx-Engine"
[Create an Issue]: https://github.com/SicroAtGit/RegEx-Engine/issues/new/choose "Create a new Issue at SicroAtGit/RegEx-Engine"
